module spfab.vector2;

private import std.string;

struct Vector2{
    void x(int v){ x_ = cast(double)v; }
    void y(int v){ y_ = cast(double)v; }
    void x(double v){ x_ = v; }
    void y(double v){ y_ = v; }
    double x(){ return x_; }
    double y(){ return y_; }
    
    void opAddAssign(ref Vector2 another){
        x_ += another.x;
        y_ += another.y;
    }
    
    void opSubAssign(ref Vector2 another){
        x_ -= another.x;
        y_ -= another.y;
    }
    
    void opDivAssign(ref Vector2 another){
        x_ /= another.x;
        y_ /= another.y;
    }
    
    Vector2 opNeg(){
        return Vector2(-x_, -y_);
    }
    
    Vector2 opAdd(ref Vector2 another){
        return Vector2(x_ + another.x, y_ + another.y);
    }
    
    Vector2 opSub(ref Vector2 another){
        return Vector2(x_ - another.x, y_ - another.y);
    }
    
    Vector2 opMul(ref Vector2 another){
        return Vector2(x_ * another.x, y_ * another.y);
    }
    
    void setInterpolation(ref Vector2 a, ref Vector2 ab, ref Vector2 ac, double u, double v){
        x_ = a.x + ab.x * u + ac.x * v;
        y_ = a.y + ab.y * u + ac.y * v;
    }
    
    void set(Vector2 v){
        x_ = v.x;
        y_ = v.y;
    }
    
    char[] toString(){
        return std.string.toString(x_) ~ "," ~ std.string.toString(y_);
    }
private:
    double x_;
    double y_;
}
